<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Home extends CI_Controller {

	/* pantalla de login */
	public function index()
	{
		$tipususuari = $this->config->item('tipus_usuari');
		/* Si esta loguejat enviem al seu panell segons tipus */
		if(is_logged() && isset( $tipususuari[$this->session->userdata('tipus')] )){
			$urlpart = $tipususuari[$this->session->userdata('tipus')]."/";
			redirect(base_url().$urlpart);
		}
		
		$data['error'] = "";
		if($this->input->post('login')){
			//recepcio i filtrat de dades POST
			$mail = filter_var($this->input->post('mail'), FILTER_SANITIZE_EMAIL);
			$clau = filter_var($this->input->post('clau'), FILTER_SANITIZE_STRING);
			
			//Si estan buides error
			if(empty($mail) || empty($clau)){
				$data['error'] = "Error: Mail o clau no especificats";
			}else{
				//consultar si existeix un usuari amb aquestes dades
				$this->load->model('Usuari_model','',TRUE);
				$usuaridades = $this->Usuari_model->loginUsuari($mail, sha1($clau));
				if($usuaridades == null){
					$data['error'] = "Dades d'usuari incorrectes";
				}else{
					//crea sessio i redirigir al panell segons el tipus d'usuari
					create_login_session($usuaridades['idusuari'], $usuaridades['nom']." ".$usuaridades['cognoms'], $usuaridades['tipus']);
					$urlpart = $tipususuari[$usuaridades['tipus']]."/";
					redirect(base_url().$urlpart);
				}
			}
		}	 	
		$this->load->view('home_login', $data);
	}
		
	/* Logout destruir session */
	public function logout()
	{
		destroy_login_session();
		redirect(URL);
	}
	
}

?>