<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Usuari extends CI_Controller {
	private $tipus;
	
	public function __construct(){
		parent::__construct();			
		/* Comprovació d'acces en el constructor per a totes les funcions */
		if(!is_logged()){
			redirect(base_url());
			exit;
		}
		$tipususuari = $this->config->item('tipus_usuari');
		$this->tipus = $tipususuari[$this->session->userdata('tipus')];
	}
	
	/*
	 * Carrega les dades d'usuari junt amb el formulari d'editar contrasenya
	 */
	public function index(){
		$this->load->model('Usuari_model','',TRUE);
		$dadesUsuari = $this->Usuari_model->dadesUsuari($this->session->userdata('idusuario'));
		if($dadesUsuari == null){
			redirect(base_url());
		}
		
		if($this->session->userdata('tipus')=="2" || $this->session->userdata('tipus')=="3"){
			$this->load->model('Assignatura_model','',TRUE);
			$data['assignatures'] = $this->Assignatura_model->assignaturesUsuari($this->session->userdata('idusuario'));
		}
		
		
		$data['dades'] = $dadesUsuari;
		
		$data['page']=$this->tipus."/perfil";
		$this->load->view('home', $data);		
	}
	
	/* 
	 * Rep per POST les 2 contrasenyes i si coincideixen i no son nulles, modifica la contrasenya d'usuari
	 * Retorna una modal html codificada en JSON per anunciar si s'ha realitzat amb exit
	 */
	public function editar_usuari(){
		$this->load->model('Usuari_model','',TRUE);
		$dadesUsuari = $this->Usuari_model->dadesUsuari($this->session->userdata('idusuario'));
		if($dadesUsuari == null){
			$this->_print_error("Error inesperat");
		}
		
		$pass = $this->input->post('pass');
		$passrepeat = $this->input->post('passrepeat');
		
		if(empty($pass) || empty($passrepeat)){
			$this->_print_error("Error al rebre les dades");
		}
		
		if($pass!=$passrepeat){
			$this->_print_error("Les contrasenyes no coincideixen");
		}
		
		$password = sha1($pass);		
		if(!$this->Usuari_model->canviarPass($this->session->userdata('idusuario'),$password)){
			$this->_print_error("Error al canviar la contrasenya");
		}
		
		$tmpl_msg = $this->load->view('modals/canvi_contrasenya', '',TRUE);	
		$json = array('error'=>'0', 'msg'=>$tmpl_msg);	
		 echo json_encode($json);
	}
	
	/* 
	 * Retorna errors en format json per ser interpretats per el js de les peticions ajax 
	 */
	private function _print_error($msg=""){
		$tmpl_msg = $this->load->view('modals/errors', array("error_msg"=>$msg), TRUE);
        $json = array('error'=>'1', 'msg'=>$tmpl_msg);
        echo json_encode($json);
        exit;
    }
}
	
