<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

if ( ! function_exists('create_login_session'))
{
	function create_login_session($iduser,$nomcomplet,$tipus)
	{
		$CI =& get_instance();
		$length_salt = $CI->config->item('length_salt');
		$random = cadena_aleatoria(60);
        $salt = substr($random, 0, $length_salt);

		$ip_user = $_SERVER['REMOTE_ADDR'];
        $useragent = $_SERVER["HTTP_USER_AGENT"];
        $hash_user = sha1($salt . $ip_user . $useragent . $iduser . $tipus);
        $signature = $salt . $hash_user;

		$sessiondata = array('isLogged' => true, 'idusuario' => $iduser, 'nom' => $nomcomplet, 'tipus' => $tipus, 'signature' => $signature);
		$CI->session->set_userdata($sessiondata);
	}
}


if ( ! function_exists('is_logged'))
{
	function is_logged()
	{
		$CI =& get_instance();
		$length_salt = $CI->config->item('length_salt');
		if($CI->session->userdata('idusuario') && $CI->session->userdata('isLogged') == TRUE){
			$iprecreate = $_SERVER['REMOTE_ADDR'];
    		$useragentrecreate = $_SERVER["HTTP_USER_AGENT"];
    		$signaturerecreate = $CI->session->userdata('signature');
    		
    		$saltrecreate = substr($signaturerecreate, 0, $length_salt);
    		 
    		$originalhash = substr($signaturerecreate, $length_salt, 40);
    		$hashrecreate = sha1($saltrecreate . $iprecreate . $useragentrecreate . $CI->session->userdata('idusuario') . $CI->session->userdata('tipus'));
    		if (!($hashrecreate == $originalhash)) {
    			$sessiondata = array('isLogged' => '', 'idusuario' => '', 'nom' => '', 'tipus' => '', 'signature' => '');
				$CI->session->unset_userdata($sessiondata);
    			return false;    			
    		}else{
    			return true;
    		}
		}else{
			return false;
		}
	}
}

if ( ! function_exists('destroy_login_session'))
{
	function destroy_login_session()
	{
		$CI =& get_instance();
		$sessiondata = array('isLogged' => '', 'idusuario' => '', 'nom' => '', 'tipus' => '', 'signature' => '');
		$CI->session->unset_userdata($sessiondata);
	}
}

if ( ! function_exists('cadena_aleatoria'))
{
	function cadena_aleatoria($long = 50) {		
		$str = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890";
		$cad = "";
		$str_len = strlen($str);
		for($i=0;$i<$long;$i++) {
			$cad .= substr($str,rand(0,$str_len-1),1);
		}
		return $cad;
	}
}


