<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Examen_model extends CI_Model {
	
	/* retorna array amb llistat d'examens actius de un professor*/
	function llistarExamensActius($idprofessor = null){
    	if($idprofessor == null) return null;
    	$sql = 'SELECT e.*, a.nom ' .
    			'FROM examen as e ' .
    			'INNER JOIN assignatura AS a ON a.idassignatura = e.idassignatura ' .
    			'WHERE e.idprofessor = "'.$idprofessor.'" ' .
	    			'AND e.data_fi > NOW() ' .
	    			'AND e.tancat = "0" ' .
    			'ORDER BY nom ASC, titul ASC';   
		$query = $this->db->query($sql);        
        return $query->result_array();  
    } 
	
	/* retorna array de examens acabats de un professor*/
	function llistarExamensAcabats($idprofessor = null){
    	if($idprofessor == null) return null;
    	$sql = 'SELECT e.*, a.nom ' .
    			'FROM examen as e ' .
    			'INNER JOIN assignatura AS a ON a.idassignatura = e.idassignatura ' .
    			'WHERE e.idprofessor = "'.$idprofessor.'" ' .
	    			'AND e.data_fi < NOW() ' .
    			'ORDER BY nom ASC, titul ASC';   
		$query = $this->db->query($sql);        
        return $query->result_array();  
    } 
    
    /* examens actius de un alumne*/
    function examensActiusAlumne($idalumne = null){
    	if($idalumne == null) return null;
    	$sql = 'SELECT e.*, a.nom, ae.idexamen as fet ' .
    			'FROM examen as e ' .
    			'INNER JOIN assignatura AS a ON a.idassignatura = e.idassignatura ' .
    			'INNER JOIN cursant AS c ON c.idassignatura = e.idassignatura ' .
    			'LEFT OUTER JOIN (SELECT * FROM alumne_examen WHERE idusuari = "'.$idalumne.'" ) AS ae ON ae.idexamen = e.idexamen ' .
    			'WHERE c.idusuari="'.$idalumne.'" ' .
    			'AND e.data_fi > NOW() ' .
    			'AND e.tancat = "0" ' .
    			'ORDER BY nom ASC, data_inici ASC';   
		$query = $this->db->query($sql);        
        return $query->result_array();  
    }
    
    /* exames acabats de un alumne concret*/
    function examensAcabatsAlumne($idalumne = null){
    	if($idalumne == null) return null;
    	$sql = 'SELECT e.*, a.nom, n.nota ' .
    			'FROM examen as e ' .
    			'INNER JOIN assignatura AS a ON a.idassignatura = e.idassignatura ' .
    			'INNER JOIN cursant AS c ON c.idassignatura = e.idassignatura ' .
    			'LEFT OUTER JOIN notes AS n ON n.idusuari = c.idusuari AND n.idexamen = e.idexamen ' .	
    			'WHERE c.idusuari="'.$idalumne.'" ' .
    			'AND e.data_fi < NOW() ' .
    			'ORDER BY nom ASC, data_inici ASC';   
		$query = $this->db->query($sql);        
        return $query->result_array();  
    }
    
    /* Sino retorna null l'examen en valid pel realitzarlo per l'alumne */
    function examenValid($idexamen = null, $idalumne = null){
    	if($idexamen == null || $idalumne == null) return null;
    	$sql = 'SELECT e.idexamen, ae.idexamen as fet ' .
    			'FROM examen as e ' .
    			'INNER JOIN assignatura AS a ON a.idassignatura = e.idassignatura ' .
    			'INNER JOIN cursant AS c ON c.idassignatura = e.idassignatura ' .
    			'LEFT OUTER JOIN (SELECT * FROM alumne_examen WHERE idusuari = "'.$idalumne.'" ) AS ae ON ae.idexamen = e.idexamen ' .
    			'WHERE c.idusuari="'.$idalumne.'" ' .
    			'AND e.idexamen="'.$idexamen.'" ' .
    			'AND e.data_fi > NOW() ' .
    			'AND e.data_inici < NOW() ' .
    			'AND e.tancat = "0" ' .
    			'LIMIT 1';   
		$query = $this->db->query($sql);        
        return $query->row_array();  
    }
    
    /* informacio basica de un examen*/
    function infoExamen($idexamen){
    	$sql = 'SELECT e.*, a.nom as nomassignatura ' .
    			'FROM examen as e ' .
    			'INNER JOIN assignatura AS a ON a.idassignatura = e.idassignatura ' .
    			'WHERE idexamen = "'.$idexamen.'" ' .
    			'LIMIT 1';   
		$query = $this->db->query($sql);        
        return $query->row_array();  
    }
    
    /* Per verificar que es pot donar per tancat i publicar notes*/
    function infoExamenNotes($idexamen, $idprofessor){
    	$sql = 'SELECT e.*, a.nom as nomassignatura '  .
    			'FROM examen as e ' .
    			'INNER JOIN assignatura AS a ON a.idassignatura = e.idassignatura ' .
    			'WHERE idexamen = "'.$idexamen.'" ' .
    			'AND idprofessor = "'.$idprofessor.'" ' .
    			'AND data_fi < NOW() ' .
    			'LIMIT 1';   
		$query = $this->db->query($sql);        
        return $query->row_array();  
    }
    
    /* Per verificar si un alumne pot veure les notes del examen en concret*/
    function infoExamenAlumne($idexamen, $idalumne){
    	$sql = 'SELECT e.*, a.nom as nomassignatura, p.nom, p.cognoms ' .
    			'FROM examen as e ' .
    			'INNER JOIN assignatura AS a ON a.idassignatura = e.idassignatura ' .
    			'INNER JOIN cursant AS c ON c.idassignatura = e.idassignatura ' .
    			'INNER JOIN usuari AS p ON e.idprofessor = p.idusuari ' .
    			'WHERE c.idusuari="'.$idalumne.'" ' .
    			'AND idexamen = "'.$idexamen.'" ' .
    			'AND data_fi < NOW() ' .
    			'AND e.tancat = "1" ' .
    			'LIMIT 1';   
		$query = $this->db->query($sql);        
        return $query->row_array();     	
    }
    
    /* crea un examen amb les dades basiques*/
    function crearExamen($sqldata){
		$this->db->insert('examen', $sqldata); 
    	return $this->db->insert_id();
    }
    
    /*edita les dades basiques d'un examen */
    function editarExamen($idexamen, $sqldata){		
		$this->db->where('idexamen', $idexamen);
		return $this->db->update('examen', $sqldata); 		
	}
	
	/* elimina un examen i totes les seves preguntes i respostes. Utilitzant transaccions*/
	function deleteExamen($idexamen){   
		$this->db->trans_start(); 	
        $this->db->query('DELETE FROM resposta WHERE idpregunta IN (SELECT idpregunta FROM pregunta WHERE idexamen ="'.$idexamen.'")');
        $this->db->query('DELETE FROM pregunta WHERE idexamen="'.$idexamen.'" ');
		$this->db->query('DELETE FROM examen WHERE idexamen="'.$idexamen.'" ');
		$this->db->trans_complete();
        return $this->db->trans_status();
    }
    
    /* elimina una pregunta i totes les seves respostes de les bases  de dades utilitzant transaccions*/
    function deletePregunta($idpregunta){
		$this->db->trans_start();
        $this->db->query('DELETE FROM resposta WHERE idpregunta="'.$idpregunta.'" ');
        $this->db->query('DELETE FROM pregunta WHERE idpregunta="'.$idpregunta.'" ');
        $this->db->trans_complete();
        return $this->db->trans_status();
    }
    
    /* guarda pregunta sense respostes a la base de dades */
    function crearPregunta($sqldata){
		$this->db->insert('pregunta', $sqldata); 
    	return $this->db->insert_id();
    }
    
    /* Guardar respostes a la base de dades*/
    function crearResposta($sqldata){
		$this->db->insert('resposta', $sqldata); 
    	return $this->db->insert_id();
    }
    
    /* Editar text de la pregunta*/
    function editarPregunta($idpregunta, $sqldata){		
		$this->db->where('idpregunta', $idpregunta);
		return $this->db->update('pregunta', $sqldata); 		
	}
	
	/* Editar resposta concreta*/
	function editarResposta($idresposta, $sqldata){		
		$this->db->where('idresposta', $idresposta);
		return $this->db->update('resposta', $sqldata); 		
	}
	
	/* retorna el llistat de preguntes d'un examen*/
	function llistatPreguntes($idexamen = null){
    	if($idexamen == null) return null;
    	$sql = 'SELECT * ' .
    			'FROM pregunta ' .
    			'WHERE idexamen = "'.$idexamen.'"';   
		$query = $this->db->query($sql);        
        return $query->result_array();  
    }
    
    /* Retorna el llistat de respostes d'una pregunta concreta*/
    function llistatRespostes($idpregunta = null){
    	if($idpregunta == null) return null;
    	$sql = 'SELECT * ' .
    			'FROM resposta ' .
    			'WHERE idpregunta = "'.$idpregunta.'"';   
		$query = $this->db->query($sql);        
        return $query->result_array();  
    }
    
    /* guarda totes les respostes enviades per un alumne i la realitzacio i data del examen utilitzant transaccions */
    function insertarRespostesAlumne($sql, $idusuari, $idexamen){
		$this->db->trans_start();
		$this->db->query('INSERT INTO alumne_resposta (idusuari, idexamen, idpregunta, idresposta) VALUES ' . implode(',', $sql) );
		$this->db->query('INSERT INTO alumne_examen (idusuari, idexamen, data) VALUES ("'.$idusuari.'","'.$idexamen.'", NOW())' );
		$this->db->trans_complete();
		return $this->db->trans_status();
    }
    
    /* retorna array de respostes correctes d'un examen */
    function respostesCorrectesExamen($idexamen = null){
    	if($idexamen == null) return null;
    	$sql = 'SELECT idpregunta, idresposta ' .
    			'FROM resposta ' .
    			'WHERE idexamen = "'.$idexamen.'" ' .
				'AND correcte="1" ' .
				'ORDER BY idpregunta ASC';   
		$query = $this->db->query($sql);        
        return $query->result_array();  
    }
    
    /* Retorna array de respostes d'un alumne a un examen */
    function respostesAlumneExamen($idexamen = null, $idalumne = null){
    	if($idexamen == null || $idalumne == null) return null;
    	$sql = 'SELECT idpregunta, idresposta ' .
    			'FROM alumne_resposta ' .
    			'WHERE idexamen = "'.$idexamen.'" ' .
				'AND idusuari = "'.$idalumne.'" ' .
				'ORDER BY idpregunta ASC';   
		$query = $this->db->query($sql);        
        return $query->result_array();  
    }
    
    /* Rep un array de correccions d'un examen i les guarda en notes despres dona per tancat el examen editant el camp tancat */
    function publicarNotes($idexamen = null, $sqlarr = null){
    	if($idexamen == null || $sqlarr == null) return false;
    	$this->db->trans_start();
    	foreach($sqlarr as $idusuari => $r){
    		$this->db->query('INSERT INTO notes (idusuari, idexamen, nota, correctes, errors) ' .
    				'VALUES ("'.$idusuari.'","'.$idexamen.'","'.$r['nota'].'","'.$r['correctes'].'","'.$r['errors'].'") ');
    	}		
		$this->db->query('UPDATE examen SET tancat="1" WHERE idexamen = "'.$idexamen.'" ' );
		$this->db->trans_complete();
		return $this->db->trans_status();
    }
    
    /* Retorna llistat de notes dels alumnes en un examen */
    function usuarisNotesExamen($idexamen = null){
    	if($idexamen == null) return false;
    	$sql = 'SELECT n.*, ae.data, u.nom, u.cognoms, u.nif ' .
    			'FROM notes AS n ' .
    			'INNER JOIN usuari as u ON n.idusuari = u.idusuari ' .
    			'LEFT OUTER JOIN alumne_examen AS ae ON n.idusuari = ae.idusuari AND n.idexamen = ae.idexamen ' .				
				'WHERE n.idexamen = "'.$idexamen.'"';   
		$query = $this->db->query($sql);        
        return $query->result_array();  
    }
    
    /* Per validar si un usuari ha obtingut nota en un examen avans de mostrar la plana de correccio d'aquest */
    function alumneNotaExamen($idexamen = null, $idalumne = null){
    	if($idexamen == null || $idalumne == null) return null;
    	$sql = 'SELECT n.*, u.nom, u.cognoms, u.nif ' .
    			'FROM notes AS n ' .
				'INNER JOIN usuari as u ON n.idusuari = u.idusuari ' .
				'WHERE n.idexamen = "'.$idexamen.'" ' .
				'AND n.idusuari = "'.$idalumne.'" ' .
				'LIMIT 1';   
		$query = $this->db->query($sql);        
        return $query->row_array();  
    }

}

