<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Usuari_model extends CI_Model {
   
   /* Comprobacio de login, si existeix usuari amb mail i clau retorna dades */
   function loginUsuari($mail, $clau){
    	$sql = 'SELECT idusuari, nom, cognoms, mail, tipus
				FROM usuari
				WHERE mail="'.$mail.'" AND clau="'.$clau.'"';   
		$query = $this->db->query($sql);        
        return $query->row_array();
    }  
    
    /* Per comprobar que no existeixi cap usuari amb el mateix mail */
    function existeixMailUsuari($mail){
    	$sql = 'SELECT mail 
				FROM usuari 
			    WHERE mail="'.$mail.'" LIMIT 1';   
		$query = $this->db->query($sql);        
        return $query->row_array();  
    }  
    
    /* Per comrpobar que no existeixi cap usuari amb el mateix NIF */
    function existeixNifUsuari($nif){
    	$sql = 'SELECT nif 
				FROM usuari 
			    WHERE nif="'.$nif.'" LIMIT 1';   
		$query = $this->db->query($sql);        
        return $query->row_array();  
    } 
    
    /* Retorna array d'usuaris segons el tipus rebut */
    function llistarUsuaris($tipus = null){
    	if($tipo = null) return null;
    	$sql = 'SELECT idusuari, nif, nom, cognoms, tipus 
				FROM usuari 
			    WHERE tipus="'.$tipus.'" ORDER BY nom ASC';   
		$query = $this->db->query($sql);        
        return $query->result_array();  
    }  
    
    /* Crear usuari nou */
    function crearUsuari($sqldata){
		$this->db->insert('usuari', $sqldata); 
    	return $this->db->insert_id();
    }    
    
    /* Elimina un alumne del sistema borrant tot lo relacionat amb ell*/
    function deleteAlumne($idusuari){    	
    	$this->db->trans_start(); 	
    	$this->db->query('DELETE FROM alumne_examen WHERE idusuari="'.$idusuari.'" ');
    	$this->db->query('DELETE FROM alumne_resposta WHERE idusuari="'.$idusuari.'" ');
    	$this->db->query('DELETE FROM cursant WHERE idusuari="'.$idusuari.'" ');
    	$this->db->query('DELETE FROM missatge WHERE idremitent="'.$idusuari.'" OR iddestinatari="'.$idusuari.'" ');
    	$this->db->query('DELETE FROM notes WHERE idusuari="'.$idusuari.'" ');
        $this->db->query('DELETE FROM usuari WHERE idusuari="'.$idusuari.'" ');        
		$this->db->trans_complete();
        return $this->db->trans_status();
    }
    
    /* Elimina un professor del sistema borrant tot lo relacionat amb ell*/
    function deleteProfessor($idusuari){    	
    	$this->db->trans_start(); 	
    	$this->db->query('DELETE FROM cursant WHERE idusuari="'.$idusuari.'" ');
    	$this->db->query('DELETE FROM missatge WHERE idremitent="'.$idusuari.'" OR iddestinatari="'.$idusuari.'" ');
    	$this->db->query('DELETE FROM notes WHERE idexamen IN (SELECT idexamen FROM examen WHERE idprofessor="'.$idusuari.'")');
    	$this->db->query('DELETE FROM pregunta WHERE idexamen IN (SELECT idexamen FROM examen WHERE idprofessor="'.$idusuari.'")');
    	$this->db->query('DELETE FROM resposta WHERE idexamen IN (SELECT idexamen FROM examen WHERE idprofessor="'.$idusuari.'")');
    	$this->db->query('DELETE FROM examen WHERE idprofessor="'.$idusuari.'" ');
        $this->db->query('DELETE FROM usuari WHERE idusuari="'.$idusuari.'" ');        
		$this->db->trans_complete();
        return $this->db->trans_status();
    }
    
    /* Retorna les dades d'un usuari */
    function dadesUsuari($idusuari){
		$sql = 'SELECT nif, nom, cognoms, mail ' .
				'FROM usuari ' .
				'WHERE idusuari = ' . $idusuari;
		return $this->db->query($sql)->row_array();
	}

	/* Edita les dades d'un usuari*/
	function editarUsuari($idusuari, $sqldata){		
		$this->db->where('idusuari', $idusuari);
		return $this->db->update('usuari', $sqldata); 		
	}
	
	/* Borra les assignatures d'un usuari */
	function resetUsuariAssignatures($idusuari){		
		$sql = 'DELETE FROM cursant ' .
        		'WHERE idusuari="'.$idusuari.'" ';
        return $this->db->query($sql);		
	}
	
	/* Inserta assignatures a un usuari */
	function insertarUsuariAssignatura($idusuari,$idassignatura){
    	$sql = 'INSERT INTO cursant ' .
    			'(idusuari, idassignatura) ' .
    			'VALUES ("'.$idusuari.'", "'.$idassignatura.'")';
        return $this->db->query($sql);
    }
    
    /* Retorna id's d'assignatures que cursa un usuari per marcar els checkboxs d'assignatures en la edicio d'usuari*/
    function assignaturesUsuari($idusuari){ //TODO buscar on
		$sql = 'SELECT idassignatura ' .
				'FROM cursant ' .
				'WHERE idusuari = ' . $idusuari;
		return $this->db->query($sql)->result_array();
	}
	
	/* Llistat d'alumnes que cursen una assignatura */
	function alumnesAssignatura($idassignatura){
		if($idassignatura == null) return null;
    	$sql = 'SELECT u.idusuari,u.nom,u.cognoms, u.mail ' .
    			'FROM usuari as u ' .
    			'INNER JOIN cursant AS c ON c.idusuari = u.idusuari ' .
    			'WHERE c.idassignatura = "'.$idassignatura.'" ' .
    			'AND u.tipus = "3" ' .
    			'ORDER BY nom ASC';   
		$query = $this->db->query($sql);        
        return $query->result_array();  
    } 
    
    /* Editar contrasenya d'usuari */
    function canviarPass($idusuari, $clau){
    	if($idusuari == null) return null;
    	$sql = 'UPDATE usuari ' .
    			'SET clau="'.$clau.'" ' .
    			'WHERE idusuari="'.$idusuari.'"';        		
        return $this->db->query($sql); 
    }    
    
}


