/*
BASES DE DADES DEL TFC
JORDI RODRIGUEZ DIAZ
APLICACIONS WEB PER A TREBALL COLABORATIU
GENQUIZ
*/

SET FOREIGN_KEY_CHECKS=0;

-- ----------------------------
-- Table structure for `alumne_examen`
-- ----------------------------
DROP TABLE IF EXISTS `alumne_examen`;
CREATE TABLE `alumne_examen` (
  `idusuari` int(10) NOT NULL,
  `idexamen` int(10) NOT NULL,
  `data` datetime NOT NULL,
  PRIMARY KEY (`idusuari`,`idexamen`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of alumne_examen
-- ----------------------------

-- ----------------------------
-- Table structure for `alumne_resposta`
-- ----------------------------
DROP TABLE IF EXISTS `alumne_resposta`;
CREATE TABLE `alumne_resposta` (
  `idusuari` int(10) NOT NULL,
  `idexamen` int(10) NOT NULL,
  `idpregunta` int(10) NOT NULL,
  `idresposta` int(10) NOT NULL,
  PRIMARY KEY (`idusuari`,`idexamen`,`idpregunta`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of alumne_resposta
-- ----------------------------

-- ----------------------------
-- Table structure for `assignatura`
-- ----------------------------
DROP TABLE IF EXISTS `assignatura`;
CREATE TABLE `assignatura` (
  `idassignatura` int(1) NOT NULL AUTO_INCREMENT,
  `nom` varchar(150) NOT NULL,
  PRIMARY KEY (`idassignatura`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of assignatura
-- ----------------------------

-- ----------------------------
-- Table structure for `cursant`
-- ----------------------------
DROP TABLE IF EXISTS `cursant`;
CREATE TABLE `cursant` (
  `idusuari` int(10) NOT NULL,
  `idassignatura` int(10) NOT NULL,
  PRIMARY KEY (`idusuari`,`idassignatura`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of cursant
-- ----------------------------

-- ----------------------------
-- Table structure for `examen`
-- ----------------------------
DROP TABLE IF EXISTS `examen`;
CREATE TABLE `examen` (
  `idexamen` int(10) NOT NULL AUTO_INCREMENT,
  `idassignatura` int(10) NOT NULL,
  `idprofessor` int(10) NOT NULL,
  `titul` text NOT NULL,
  `data_inici` datetime NOT NULL,
  `data_fi` datetime NOT NULL,
  `tancat` enum('1','0') NOT NULL DEFAULT '0',
  PRIMARY KEY (`idexamen`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of examen
-- ----------------------------

-- ----------------------------
-- Table structure for `missatge`
-- ----------------------------
DROP TABLE IF EXISTS `missatge`;
CREATE TABLE `missatge` (
  `idmissatge` int(10) NOT NULL AUTO_INCREMENT,
  `idremitent` int(10) NOT NULL,
  `iddestinatari` int(10) NOT NULL,
  `asunte` varchar(100) NOT NULL,
  `missatge` text NOT NULL,
  `data_enviat` datetime NOT NULL,
  `llegit` enum('0','1') NOT NULL DEFAULT '0',
  `hide_sended` enum('0','1') NOT NULL DEFAULT '0',
  `hide_recived` enum('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`idmissatge`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Records of missatge
-- ----------------------------

-- ----------------------------
-- Table structure for `notes`
-- ----------------------------
DROP TABLE IF EXISTS `notes`;
CREATE TABLE `notes` (
  `idusuari` int(10) NOT NULL,
  `idexamen` int(10) NOT NULL,
  `nota` int(2) NOT NULL,
  `correctes` int(3) NOT NULL,
  `errors` int(3) NOT NULL,
  PRIMARY KEY (`idusuari`,`idexamen`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of notes
-- ----------------------------

-- ----------------------------
-- Table structure for `pregunta`
-- ----------------------------
DROP TABLE IF EXISTS `pregunta`;
CREATE TABLE `pregunta` (
  `idpregunta` int(10) NOT NULL AUTO_INCREMENT,
  `idexamen` int(10) NOT NULL,
  `pregunta` text NOT NULL,
  PRIMARY KEY (`idpregunta`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of pregunta
-- ----------------------------

-- ----------------------------
-- Table structure for `resposta`
-- ----------------------------
DROP TABLE IF EXISTS `resposta`;
CREATE TABLE `resposta` (
  `idresposta` int(10) NOT NULL AUTO_INCREMENT,
  `idpregunta` int(10) NOT NULL,
  `idexamen` int(10) NOT NULL,
  `resposta` text NOT NULL,
  `correcte` enum('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`idresposta`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of resposta
-- ----------------------------

-- ----------------------------
-- Table structure for `usuari`
-- ----------------------------
DROP TABLE IF EXISTS `usuari`;
CREATE TABLE `usuari` (
  `idusuari` int(10) NOT NULL AUTO_INCREMENT,
  `clau` char(40) NOT NULL,
  `nif` char(9) NOT NULL,
  `nom` varchar(45) NOT NULL,
  `cognoms` varchar(150) DEFAULT NULL,
  `mail` varchar(150) NOT NULL,
  `tipus` enum('1','2','3') NOT NULL,
  PRIMARY KEY (`idusuari`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of usuari
-- ----------------------------
INSERT INTO `usuari` VALUES ('1', '601f1889667efaebb33b8c12572835da3f027f78', '12345678X', 'Administrador', 'Web', 'admin@tfc.enredats.com', '1');
