var assignatura = {		
	_editurlinfo : baseurl+'administrador/assignatura_info/',
	_deleteurl : baseurl+'administrador/assignatura_delete/',
	
	init: function() {
		assignatura.validate();
		assignatura.ajaxform();
	},	
	validate: function() {
		$("#frmCrear").validate();
	},
	ajaxform: function() {	
		var options = {
		dataType:  'json',
		success:	function(data, statusText) { 
        				if(data.error==0){
        					assignatura.refresh(data.assignatures);
	        				assignatura.clearform();
	        			}else{
	        				show_error(data.msg);
	        			}     					
    				}
		}; 	
		$('#frmCrear').ajaxForm(options);
	},
	edit: function(idassignatura) {
		$.ajax({
	    	type: "POST",
			url: assignatura._editurlinfo,
			data: "idassignatura="+idassignatura,
			dataType: "json",
	        success:function(data){
				$('#action').val('edit');
				$('#idassignatura').val(idassignatura);
				if(data.error==0){
					$.each(data.assignatura, function(key, val) {
						 $(":input[name="+key+"]").val(val);
  					});
				}else{
					show_error(data.msg);
				}
	        }
		});
	},
	del: function(idassignatura) {
		if (confirm("Segur que vols eliminar aquesta assignatura? S'eliminarà tot lo relacionat amb l'assignatura (examens, notes, etc..)")) {
			$.ajax({
		    	type: "POST",
				url: assignatura._deleteurl,
				data: "idassignatura="+idassignatura,
				dataType: "json",
		        success:function(data){				
					if(data.error==0){
		        		assignatura.refresh(data.assignatures);
		        		assignatura.clearform();
		        	}else{
		        		show_error(data.msg);
		        	}
		        }
			});
		}
	},
	refresh: function(html) {
		$("#jqListAssignatures").html(html);
	},
	clearform: function() {
		$('#frmCrear').clearForm();
		$('#action').val('add');
		$('#idassignatura').val('');
 		
	}
}

var alumne = {		
	_editurlinfo : baseurl+'administrador/alumne_info/',
	_deleteurl : baseurl+'administrador/alumne_delete/',
	
	init: function() {
		alumne.validate();
		alumne.ajaxform();
	},	
	validate: function() {
		$.validator.addMethod('onecheck', function(value, ele) {
           return $("input:checked").length >= 1;
         }, 'Selecciona mínim una assignatura');
         
        $.validator.addMethod('dni', function(value, ele) {
           return validar_dni(value);
         }, 'DNI incorrecte');
          
    	$("#frmCrear").validate({
    		 errorPlacement: function(error, element) {
                    if(element.attr("type")=="checkbox"){
    		 			error.insertAfter(element.parent().parent()); 
    		 		}else{
    		 			error.insertAfter(element);
    		 		}
        	 }
    	});
	},
	ajaxform: function() {	
		var options = {
		dataType:  'json',
		success:	function(data, statusText) { 
        				if(data.error==0){
        					alumne.refresh(data.alumnes);
	        				alumne.clearform();
	        			}else{
	        				show_error(data.msg);
	        			}     					
    				}
		}; 	
		$('#frmCrear').ajaxForm(options);
	},
	edit: function(idalumne) {
		$.ajax({
	    	type: "POST",
			url: alumne._editurlinfo,
			data: "idalumne="+idalumne,
			dataType: "json",
	        success:function(data){
				$('#action').val('edit');
				$('#idalumne').val(idalumne);
				$(".onecheck").prop("checked",false);
				if(data.error==0){
					$.each(data.alumne, function(key, val) {
						 $(":input[name="+key+"]").val(val);
  					});
  					$.each(data.alumne.assignatures, function(i, obj) {
						 $("#as_"+obj.idassignatura).prop("checked",true);
  					});
				}else{
					show_error(data.msg);
				}
	        }
		});
	},
	del: function(idalumne) {
		if (confirm("Segur que vols eliminar aquest alumne? S'eliminarà tot lo realitzat amb l'alumne (examens realitzats, notes, etc..).")) {
			$.ajax({
		    	type: "POST",
				url: alumne._deleteurl,
				data: "idalumne="+idalumne,
				dataType: "json",
		        success:function(data){				
					if(data.error==0){
		        		alumne.refresh(data.alumnes);
		        		alumne.clearform();
		        	}else{
		        		show_error(data.msg);
		        	}
		        }
			});
		}
	},
	refresh: function(html) {
		$("#jqListAlumnes").html(html);
	},
	clearform: function() {
		$('#frmCrear').clearForm();
		$('#action').val('add');
		$('#idalumne').val('');
 		
	}
}

var professor = {		
	_editurlinfo : baseurl+'administrador/professor_info/',
	_deleteurl : baseurl+'administrador/professor_delete/',
	
	init: function() {
		professor.validate();
		professor.ajaxform();
	},	
	validate: function() {
		$.validator.addMethod('onecheck', function(value, ele) {
           return $("input:checked").length >= 1;
         }, 'Selecciona mínim una assignatura');
         
         $.validator.addMethod('dni', function(value, ele) {
           return validar_dni(value);
         }, 'DNI incorrecte');
         
    	$("#frmCrear").validate({
    		 errorPlacement: function(error, element) {
                    if(element.attr("type")=="checkbox"){
    		 			error.insertAfter(element.parent().parent()); 
    		 		}else{
    		 			error.insertAfter(element);
    		 		}
        	 }
    	});
	},
	ajaxform: function() {	
		var options = {
		dataType:  'json',
		success:	function(data, statusText) { 
        				if(data.error==0){
        					professor.refresh(data.professors);
	        				professor.clearform();
	        			}else{
	        				show_error(data.msg);
	        			}     					
    				}
		}; 	
		$('#frmCrear').ajaxForm(options);
	},
	edit: function(idprofessor) {
		$.ajax({
	    	type: "POST",
			url: professor._editurlinfo,
			data: "idprofessor="+idprofessor,
			dataType: "json",
	        success:function(data){
				$('#action').val('edit');
				$('#idprofessor').val(idprofessor);
				$(".onecheck").prop("checked",false);
				if(data.error==0){
					$.each(data.professor, function(key, val) {
						 $(":input[name="+key+"]").val(val);
  					});
  					$.each(data.professor.assignatures, function(i, obj) {
						 $("#as_"+obj.idassignatura).prop("checked",true);
  					});
				}else{
					show_error(data.msg);
				}
	        }
		});
	},
	del: function(idprofessor) {
		if (confirm("Segur que vols eliminar aquest professor? S'eliminarà tot lo realitzat amb el professor (examens, notes, etc..).")) {
			$.ajax({
		    	type: "POST",
				url: professor._deleteurl,
				data: "idprofessor="+idprofessor,
				dataType: "json",
		        success:function(data){				
					if(data.error==0){
		        		professor.refresh(data.professors);
		        		professor.clearform();
		        	}else{
		        		show_error(data.msg);
		        	}
		        }
			});
		}
	},
	refresh: function(html) {
		$("#jqListProfessors").html(html);
	},
	clearform: function() {
		$('#frmCrear').clearForm();
		$('#action').val('add');
		$('#idprofessor').val('');
 		
	}
}

function validar_dni(dni){
	var numero;
	var let;
	var letra;
	var expresion_regular_dni;
	
	expresion_regular_dni = /^\d{8}[a-zA-Z]$/;
	if(expresion_regular_dni.test (dni) == true){
		numero = dni.substr(0,dni.length-1);
		let = dni.substr(dni.length-1,1);
		numero = numero % 23;
		letra="TRWAGMYFPDXBNJZSQVHLCKET";
		letra=letra.substring(numero,numero+1);
		if (letra!=let) {
			return false;
		}else{
			return true;
		}	
	}else{	
		return false;
	}
}