var examen = {	
	_deleteurl : baseurl+'professor/examen_delete/',
	_pubnotesurl : baseurl+'professor/publicar_notes/',		
	
	init: function() {		
		examen.validate();
		examen.ajaxform();
		examen.datapicker();		
	},	
	validate: function() {
		$.validator.addMethod('oneselected', function(value, ele) {
           return value > 0;
         }, 'Selecciona una assignatura');
         
        $.validator.addMethod('valdate', function(value, ele) {          
  			return validarFecha(value);  			      
         }, 'Data no valida');         
		$("#frmCrear").validate();
	},
	ajaxform: function() {	
		var options = {
		dataType:  'json',
		success:	function(data, statusText) { 
        				if(data.error==0){
        					$("#idexamen").val(data.idexamen);
        					$("#data_examen").html(data.examendata).show();
        					$("#frmCrear").hide();
        					if($("#action").val()=="add"){
        						$("#action").val("edit");        					
	        					//pregunta
	        					$("#p_idexamen").val(data.idexamen);
	        					$('#frmCrearPregunta').show();        					
        					}        					
	        			}else{
	        				show_error(data.msg);
	        			}     					
    				}
		}; 	
		$('#frmCrear').ajaxForm(options);
	},
	datapicker: function(){
		$.datepicker.regional['es'] = {
			clearText: 'Borra',
			clearStatus: 'Borra fecha actual',
			closeText: 'Cerrar',
			closeStatus: 'Cerrar sin guardar',
			prevText: '<Ant',
			prevBigText: '<<',
			prevStatus: 'Mostrar mes anterior',
			prevBigStatus: 'Mostrar año anterior',
			nextText: 'Sig>',
			nextBigText: '>>',
			nextStatus: 'Mostrar mes siguiente',
			nextBigStatus: 'Mostrar año siguiente',
			currentText: 'Hoy',
			currentStatus: 'Mostrar mes actual',
			monthNames: ['Enero','Febrero','Marzo','Abril','Mayo','Junio', 'Julio','Agosto','Septiembre','Octubre','Noviembre','Diciembre'],
			monthNamesShort: ['Ene', 'Feb', 'Mar', 'Abr', 'May', 'Jun', 'Jul', 'Ago', 'Sep', 'Oct', 'Nov', 'Dic'],
			monthStatus: 'Seleccionar otro mes',
			yearStatus: 'Seleccionar otro año',
			weekHeader: 'Sm',
			weekStatus: 'Semana del año',
			dayNames: ['Domingo', 'Lunes', 'Martes', 'Miércoles', 'Jueves', 'Viernes', 'Sábado'],
			dayNamesShort: ['Dom', 'Lun', 'Mar', 'Mié', 'Jue', 'Vie', 'Sáb'],
			dayNamesMin: ['Do','Lu','Ma','Mi','Ju','Vi','Sá'],
			dayStatus: 'Set DD as first week day',
			dateStatus: 'Select D, M d',
			dateFormat: 'dd/mm/yy',
			firstDay: 1,
			initStatus: 'Seleccionar fecha',
			isRTL: false
		};	
		$.datepicker.setDefaults($.datepicker.regional['es']);
		
	 	$("#datainici").datetimepicker({
	 		showSecond: true,
			timeFormat: 'hh:mm:ss',
			minDate: new Date(),
			dateFormat: 'dd/mm/yy'
		});
	 	$("#datafi").datetimepicker({
	 		showSecond: true,
			timeFormat: 'hh:mm:ss',
			dateFormat: 'dd/mm/yy'
		});
	},
	edit: function() {
		$("#data_examen").hide();
		$("#frmCrear").show();
	},
	del: function(idexamen) {
		if (confirm("Seguro que quiere eliminar este examen?")) {
			$.ajax({
		    	type: "POST",
				url: examen._deleteurl,
				data: "idexamen="+idexamen,
				dataType: "json",
		        success:function(data){				
					if(data.error==0){
		        		examen.refresh(data.examens);
		        	}else{
		        		show_error(data.msg);
		        	}
		        }
			});
		}
	},
	pubnotes: function(idexamen){
		$.ajax({
		    	type: "POST",
				url: examen._pubnotesurl,
				data: "idexamen="+idexamen,
				dataType: "json",
		        success:function(data){				
					if(data.error==0){
		        		$.colorbox({opacity: 0.7, 
		        					title: '', 
		        					html: data.msg, 
		        					close: 'tancar', 
		        					onClosed:function(){
										window.location.href=baseurl+'professor/resultats_examen/'+idexamen;
									}});
		        	}else{
		        		show_error(data.msg);
		        	}
		        }
			});
	},
	finish: function(){
		var idexamen = $("#p_idexamen").val();
		$("#frmCrearPregunta").hide();
		$.colorbox({opacity: 0.7, 
					title: '', 
					href: baseurl+'professor/finalitzar_examen/'+idexamen, 
					close: 'tancar', 
					onClosed:function(){
						window.location.href=baseurl+'professor/examens_actius/';
					}});
		
	},
	refresh: function(html) {
		$("#jqExamensAcius").html(html);
	},
	clearform: function() {
		$('#frmCrear').clearForm(); 		
	}
}
/*********************************************************************************************************/
var pregunta = {	
	_deleteurl : baseurl+'professor/pregunta_delete/',		
	
	init: function() {
		pregunta.validate();
		pregunta.ajaxform();
	},	
	validate: function() {
		$.validator.addMethod('onecheck', function(value, ele) {
           return $("#frmCrearPregunta > input:radio:checked").length >= 1;
         }, 'Selecciona una resposta correcte');  
         $("#frmCrearPregunta").validate({
    		 errorPlacement: function(error, element) {
    		 		if(element.attr("type")=="radio"){
    		 			error.insertBefore("#pregt");
    		 		}else{
    		 			error.insertAfter(element);
    		 		}                   
        	 }
    	}); 
	},
	ajaxform: function() {	
		var options = {
		dataType:  'json',
		success:	function(data, statusText) { 
        				if(data.error==0){
        					$("#e_preguntas").append(data.pregunta);
        					pregunta.clearform();
	        			}else{
	        				show_error(data.msg);
	        			}     					
    				}
		}; 	
		$('#frmCrearPregunta').ajaxForm(options);
	},
	edit: function(idpregunta) {
		$("#data_pregunta_"+idpregunta).hide();
		$("#frmPregunta_"+idpregunta).show();
         $("#frmPregunta_"+idpregunta).validate();
    	pregunta.editform(idpregunta);
	},
	editform: function(idpregunta) {	
		var options = {
		dataType:  'json',
		success:	function(data, statusText) { 
        				if(data.error==0){
        					$("#pregunta_"+idpregunta).html(data.pregunta);
        					$("#frmPregunta_"+idpregunta).hide();
        					$("#data_pregunta_"+idpregunta).show();							
	        			}else{
	        				show_error(data.msg);
	        			}     					
    				}
		}; 	
		$("#frmPregunta_"+idpregunta).ajaxForm(options);
	},
	del: function(idpregunta) {
		if (confirm("Seguro que quiere eliminar esta pregunta?")) {
			$.ajax({
		    	type: "POST",
				url: pregunta._deleteurl,
				data: "idpregunta="+idpregunta,
				dataType: "json",
		        success:function(data){				
					if(data.error==0){
		        		$("#pregunta_"+idpregunta).remove();
		        	}else{
		        		show_error(data.msg);
		        	}
		        }
			});
		}
	},
	refresh: function(html) {
		
	},
	clearform: function() {
		$('#frmCrearPregunta').clearForm(); 		
	}
}


function validarFecha(date){	
	var data = date.split(" ")[0].split("/");
	var time = date.split(" ")[1].split(":");
	var DT = new Date (parseInt(data[2]), parseInt(data[1]-1), parseInt(data[0]), parseInt(time[0]), parseInt(time[1]), parseInt(time[2]) );
	if (isNaN(DT)) {
		return false;
	}else{
		return true;
	}
}
